

//////////////////////////////////////////////////////////////////
//                                                              //
//           PLINK (c) 2005-2006 Shaun Purcell                  //
//                                                              //
// This file is distributed under the GNU General Public        //
// License, Version 2.  Please see the file COPYING for more    //
// details                                                      //
//                                                              //
//////////////////////////////////////////////////////////////////


#ifndef __LINEAR_H__
#define __LINEAR_H__

#include<vector>
#include "plink.h"

using namespace std;

class LinearModel {

 public:

  LinearModel();


  void fitLM();
  void noCluster();
  void setCluster(vector<int> & cl);
  void setMissing(vector<bool> & m);
  void addIndependent(vector<double> & iv);
  void setDependent(vector<double> & dv);
  void reset();
  vector_t getCoefs();
  vector_t getVar();
      
  
 private:

  vector<double> Y;
  vector<vector<double> > X;
  vector<bool> miss;
  vector<int> clst;
  vector<int> C;

  vector<double> coef;
  vector<double> se;
  double chisq;
  vector<vector<double> > covar;

  vector<double> sig;
  vector<double> w;
  vector<vector<double> > u;
  vector<vector<double> > v;

  double varY;
  int nind;
  int np;
  int nc;


  bool cluster;
  void function(const int i, vector<double> & p );  
  void setVariance();
};



#endif
